/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the DynamicAddressesList200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DynamicAddressesList200Response{}

// DynamicAddressesList200Response struct for DynamicAddressesList200Response
type DynamicAddressesList200Response struct {
	Results []DynamicAddressesList200ResponseResultsInner `json:"results,omitempty"`
}

// NewDynamicAddressesList200Response instantiates a new DynamicAddressesList200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDynamicAddressesList200Response() *DynamicAddressesList200Response {
	this := DynamicAddressesList200Response{}
	return &this
}

// NewDynamicAddressesList200ResponseWithDefaults instantiates a new DynamicAddressesList200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDynamicAddressesList200ResponseWithDefaults() *DynamicAddressesList200Response {
	this := DynamicAddressesList200Response{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *DynamicAddressesList200Response) GetResults() []DynamicAddressesList200ResponseResultsInner {
	if o == nil || IsNil(o.Results) {
		var ret []DynamicAddressesList200ResponseResultsInner
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DynamicAddressesList200Response) GetResultsOk() ([]DynamicAddressesList200ResponseResultsInner, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *DynamicAddressesList200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []DynamicAddressesList200ResponseResultsInner and assigns it to the Results field.
func (o *DynamicAddressesList200Response) SetResults(v []DynamicAddressesList200ResponseResultsInner) {
	o.Results = v
}

func (o DynamicAddressesList200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DynamicAddressesList200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	return toSerialize, nil
}

type NullableDynamicAddressesList200Response struct {
	value *DynamicAddressesList200Response
	isSet bool
}

func (v NullableDynamicAddressesList200Response) Get() *DynamicAddressesList200Response {
	return v.value
}

func (v *NullableDynamicAddressesList200Response) Set(val *DynamicAddressesList200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableDynamicAddressesList200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableDynamicAddressesList200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDynamicAddressesList200Response(val *DynamicAddressesList200Response) *NullableDynamicAddressesList200Response {
	return &NullableDynamicAddressesList200Response{value: val, isSet: true}
}

func (v NullableDynamicAddressesList200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDynamicAddressesList200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


